 DirectShowFilters/TsWriter/bin/Release/TsWriter.ax | Bin 262144 -> 262656 bytes
 DirectShowFilters/TsWriter/source/DiskRecorder.cpp |  11 +++++++++++
 2 files changed, 11 insertions(+)

diff --git a/DirectShowFilters/TsWriter/bin/Release/TsWriter.ax b/DirectShowFilters/TsWriter/bin/Release/TsWriter.ax
index b6faf97..aa2891b 100644
Binary files a/DirectShowFilters/TsWriter/bin/Release/TsWriter.ax and b/DirectShowFilters/TsWriter/bin/Release/TsWriter.ax differ
diff --git a/DirectShowFilters/TsWriter/source/DiskRecorder.cpp b/DirectShowFilters/TsWriter/source/DiskRecorder.cpp
index 3e9f08b..5b60aa8 100644
--- a/DirectShowFilters/TsWriter/source/DiskRecorder.cpp
+++ b/DirectShowFilters/TsWriter/source/DiskRecorder.cpp
@@ -1104,6 +1104,17 @@ void CDiskRecorder::WriteTs(byte* tsPacket)
 						else return ;
 					}                        
 				}
+
+        // If the channel PMT does not specify a PCR PID (see ISO 13818-1 MPEG 2 TS spec
+        // page 47, TS_program_map_section, PCR_PID) then check if this packet contains
+        // PCR that we can use.
+        // See http://forum.team-mediaportal.com/threads/dvb-c-radio-not-working.118141/
+        if (m_pcrPid == 0x1fff && m_tsHeader.HasAdaptionField && m_tsHeader.AdaptionFieldLength >= 7 && (info.m_Pkt[ADAPTION_FIELD_FLAG_OFFSET] & PCR_FLAG_BIT) != 0)
+        {
+          WriteLog("currently no PCR PID, PID 0x%x appears to have PCR so we'll attempt to use it", m_tsHeader.Pid);
+          m_pcrPid = m_tsHeader.Pid;
+          DR_FAKE_PCR_PID = info.fakePid;
+        }
 	 
         if (m_tsHeader.Pid == m_pcrPid)
         {
